package protocols;

import core.*;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.lang.reflect.Array;
import java.io.ObjectOutputStream;
import java.io.ByteArrayOutputStream;
import java.math.BigInteger;

public class INITNS extends Protocol {
   
   public INITNS (ObjectOutputStream oos) {
      super("core.Message" ,"core.MessageKey" ,"core.Nonce" );
      this.oos=oos;
      }
   
   public void run() {
      try {
         
         println("creating nonce na");
         createNewNonce("na");
         
         println("Building message m1");
         Message m1 =message();
         m1.addMessage(message(agentFromId("a")));
         m1.addMessage(message(nonceFromId("na")));
         println("Encrypting m1");
         m1.encrypt("RSA", getPublicKey(nameFromId("b")));
         println("Sending message m1");
         put("b", m1.getString(),4000);
         
         println("waiting for m2");
         Message m2 = message(get("b"));
         println("Decrypting m2");
         m2.decrypt("RSA", getPrivateKey(nameFromId("a")));
         addParts(m2.getAllFields(),2);
         m0=getPart();
         setValueToNonce(m0.getString(),"na");
         m0=getPart();
         setValueToNonce(m0.getString(),"nb");
         
         
         println("Building message m3");
         Message m3 =message();
         m3.addMessage(message(nonceFromId("nb")));
         println("Encrypting m3");
         m3.encrypt("RSA", getPublicKey(nameFromId("b")));
         println("Sending message m3");
         put("b", m3.getString());
         
         writeObject(nameFromId("b"));
         writeObject(nonceFromId("na"));
         writeObject(nonceFromId("nb"));
         
         
         } catch (Exception e) {e.printStackTrace();System.exit(0);}
      }
   
   public static void subMain(String[] args,ObjectOutputStream oos) {
      INITNS a = new INITNS(oos);
      args=a.getArgs(args);
      a.start();
      }
   
   public String[] getArgs(String[] args) {
      try {
         if (args.length != 5) {
            args = (String[]) Array.newInstance("".getClass(), 5);
            BufferedReader in2 =
            new BufferedReader(new InputStreamReader(System.in));
            println("Type the KeyStore file to use  [keystore]");
            args[0]=in2.readLine();
            if (args[0].compareTo("")==0) args[0]="keystore";
            println("Type the password to access it [duitama]");
            args[1]=in2.readLine();
            if (args[1].compareTo("")==0) args[1]="duitama";
            println("Type the DNS name of agent b [localhost]");
            args[2]=in2.readLine();
            if (args[2].compareTo("")==0) args[2]="localhost";
            println("Type the name of agent a [a]");
            args[3]=in2.readLine();
            if (args[3].compareTo("")==0) args[3]="a";
            println("Type the name of agent b [b]");
            args[4]=in2.readLine();
            if (args[4].compareTo("")==0) args[4]="b";
            }
         setKS(args[0],args[1]);
         setIPToId(args[2],"b");
         setNameToId(args[3],"a");
         setNameToId(args[4],"b");
         } catch (Exception e) {e.printStackTrace();}
      return args;
      }
   
   public static void main(String[] args) {
      ObjectOutputStream oos=null;
      try {
         ByteArrayOutputStream os = new ByteArrayOutputStream();
         oos=new ObjectOutputStream(os);
         PrintOOS p=new PrintOOS("INITNS",oos,os);
         p.start();}
      catch (Exception e) {e.printStackTrace();}
      subMain(args,oos);
      }
   }