package protocols;

import core.*;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.lang.reflect.Array;
import java.io.ObjectOutputStream;
import java.io.ByteArrayOutputStream;
import java.math.BigInteger;

public class RESPDH extends Protocol {
   
   public RESPDH (ObjectOutputStream oos) {
      super("core.Message" ,"core.MessageKey" ,"core.Nonce" );
      this.oos=oos;
      }
   
   public void run() {
      try {
         BigInteger g = null;
         BigInteger m = null;
         BigInteger x = null;
         BigInteger y = null;
         BigInteger gEx = null;
         BigInteger gEy = null;
         BigInteger k = null;
         
         y=freshBI();
         
         println("waiting for m1");
         Message m1 = message(get("A",4000));
         addParts(m1.getAllFields(),3);
         m0=getPart();
         g = new BigInteger(m0.getString());
         m0=getPart();
         m = new BigInteger(m0.getString());
         m0=getPart();
         gEx = new BigInteger(m0.getString());
         
         
         k=gEx.modPow(y,m);
         gEy=g.modPow(y,m);
         println("Building message m2");
         Message m2 =message();
         m2.addMessage(message(gEy.toString()));
         println("Sending message m2");
         put("A", m2.getString());
         
         writeObject(k.toString());
         
         
         } catch (Exception e) {e.printStackTrace();System.exit(0);}
      }
   
   public static void subMain(String[] args,ObjectOutputStream oos) {
      RESPDH B;
      while (true) {
         B=new RESPDH(oos);
         args=B.getArgs(args);
         B.newAgent("A",4000);
         B.start();
         }
      }
   
   public String[] getArgs(String[] args) {
      try {
         if (args.length != 1) {
            args = (String[]) Array.newInstance("".getClass(), 1);
            BufferedReader in2 =
            new BufferedReader(new InputStreamReader(System.in));
            println("Type the name of agent B [B]");
            args[0]=in2.readLine();
            if (args[0].compareTo("")==0) args[0]="B";
            }
         setNameToId(args[0],"B");
         } catch (Exception e) {e.printStackTrace();}
      return args;
      }
   
   public static void main(String[] args) {
      ObjectOutputStream oos=null;
      try {
         ByteArrayOutputStream os = new ByteArrayOutputStream();
         oos=new ObjectOutputStream(os);
         PrintOOS p=new PrintOOS("RESPDH",oos,os);
         p.start();}
      catch (Exception e) {e.printStackTrace();}
      subMain(args,oos);
      }
   }